# Compute Fibonacci numbers (iteratively)
# Register Usage
# $a0 parameter n
# $v0 last Fibonacci number computed so far (and result)
# $t0 second last Fibonacci number computed so far
# $t1 temporary scratch register
	
	.text
	.globl main
main:
	li $a0, 1 # fib(n): parameter n
	move $v0, $a0 # n < 2 => fib(n) = n
	blt $a0, 2, done
	li $t0, 0 # second last Fib number
	li $v0, 1 # last Fib number
fib: 
	add $t1, $t0, $v0 # compute next Fib number in sequence
	move $t0, $v0 # update second last
	move $v0, $t1 # update last
	sub $a0, $a0, 1 # more work to do?
	bgt $a0, 1, fib # yes: iterate again
done: 
	sw $v0, result # no: store result, done
	.data
result: 
	.word 0x11111111

